#version unofficial megapov 0.7;

#declare r_trr=seed(106);
#declare ripples_tmp=1000*rand(r_trr);
#declare p_hf1=
function{
 pigment{
  ripples turbulence .7
  cubic_wave
  pigment_map{
   [0.00 White]
   [0.10 White]
   [1.00 Black]
  }
  scale .3
  translate ripples_tmp
 }
}
#declare p_hf2=
function{
 pigment{
  pigment_pattern{
   gradient x
   turbulence .025 lambda 3
   color_map{
    [0.0 Black]
    [0.4 Black]
    [0.475 White]
    [0.485 White*.975]
    [0.494 White*.975]
    [0.496 White*.95]
    [0.498 White*.925]
    [0.500 White]
    [0.502 White*.925]
    [0.504 White*.95]
    [0.506 White*.975]
    [0.515 White*.975]
    [0.525 White]
    [0.6 Black]
    [1.0 Black]
   }
  }
  pigment_map{
   [0.00 Black]
   [1.00 Gray80]
  }
//  warp{reset_children}
  scale .3
  translate <.04,0,13>
 }
}
#declare f_max =
function{max(p_hf1(x,y,z),p_hf2(x,y,z))}
#declare land=
difference{
 height_field{
  pattern 512*terrhf_k,512*terrhf_k{
    hf_gray_16
    function{f_max(x,y,z)}
    color_map{
    [0.00 Black]
    [1.00 White]
    }
  }
  translate -.5
 }
 box{-.5,.5 scale <.1,1.2,.1> translate -.4*z}
}
#declare land_fake=
difference{
 height_field{
  pattern 32,32{
    hf_gray_16
    function{f_max(x,y,z)}
    color_map{
    [0.00 Black]
    [1.00 White]
    }
  }
  translate -.5
 }
 box{-.5,.5 scale <.1,1.2,.1> translate -.4*z}
}

#if (use_plants)
#declare num_leaves=8;
#declare cnt_leaves=1;
#declare min_height=5;
#declare max_height=8;
#declare medium_radius=.2;
#declare base_radius=.6;
#declare plant1=
mesh{
#while (cnt_leaves<=num_leaves)
  #include "i_leaf.inc"
 #declare cnt_leaves=cnt_leaves+1;
#end
}
#declare num_leaves=9;
#declare cnt_leaves=1;
#declare min_height=3;
#declare max_height=10;
#declare medium_radius=.2;
#declare base_radius=.5;
#declare plant2=
mesh{
#while (cnt_leaves<=num_leaves)
  #include "i_leaf.inc"
 #declare cnt_leaves=cnt_leaves+1;
#end
}
#declare num_leaves=6;
#declare cnt_leaves=1;
#declare min_height=6;
#declare max_height=9;
#declare medium_radius=.3;
#declare base_radius=.2;
#declare plant3=
mesh{
#while (cnt_leaves<=num_leaves)
  #include "i_leaf.inc"
 #declare cnt_leaves=cnt_leaves+1;
#end
}
#declare num_leaves=7;
#declare cnt_leaves=1;
#declare min_height=3;
#declare max_height=8;
#declare medium_radius=.2;
#declare base_radius=.4;
#declare plant4=
mesh{
#while (cnt_leaves<=num_leaves)
  #include "i_leaf.inc"
 #declare cnt_leaves=cnt_leaves+1;
#end
}
#declare cnt_plants=0;
#declare plants=
union{
#while (cnt_plants<num_plants)
 #declare Norm = <0, 0, 0>;
 #declare Start = <-.2+.7*rand(r_plant),.6,-.5+rand(r_plant)>;
 #declare Direc = <0,-1,0>;
 #declare Inter=trace ( land, Start, Direc, Norm );
 #if (Inter.y>.05 & Inter.y<.15)
  #declare k=.1+rand(r_plant)*.2;
  #if (rand(r_plant)<=.25)
  object{plant1
  #else
   #if (rand(r_plant)<=.33)
   object{plant2
   #else
    #if (rand(r_plant)<=.5)
    object{plant3
    #else
    object{plant4
    #end
   #end
  #end
   texture{pigment{Gold*(1-k)*.5+Green*k+Gray10*(1-k)*.5}}
   scale <1.5,70+20*rand(r_plant),1.5>
   scale .00075+0.00025*rand(r_plant)
   rotate (360*rand(r_plant))*y
   translate <Start.x,Inter.y,Start.z>
  }
  #declare cnt_plants=cnt_plants+1;
 #end
#end
}
#end
#if (use_grass)
#declare num_leaves=32;
#declare cnt_leaves=1;
#declare min_height=2;
#declare max_height=4;
#declare medium_radius=.1;
#declare base_radius=4;
#declare grass_patch=
mesh{
#while (cnt_leaves<=num_leaves)
  #include "i_grass.inc"
 #declare cnt_leaves=cnt_leaves+1;
#end
 scale <.25,.1,.25>
}
#declare cnt_grass=0;
#declare grass=
union{
#while (cnt_grass<num_grass)
 #declare Norm = <0, 0, 0>;
 #declare Start = <-.2+.7*rand(r_plant),.6,-.5+rand(r_plant)>;
 #declare Direc = <0,-1,0>;
 #declare Inter=trace ( land, Start, Direc, Norm );
 #if (Inter.y>.1 & Inter.y<.25)
   object{grass_patch
    texture{
     pigment{
      bozo turbulence 1
      color_map{
       [0.0 Gold*.2+Green*.2+Gray10+Yellow*.2]
       [1.0 Green*.3+Gold*.1+Gray10+Yellow*.1]
      }
      frequency 2
     }
     scale 100
     translate 1000*rand(r_plant)
    }
    rotate (360*rand(r_plant))*y
    scale <1.5,90,1.5>
    scale .0005+0.001*rand(r_plant)
    scale 4
    translate <Start.x,Inter.y,Start.z>
   }
   #declare cnt_grass=cnt_grass+1;
 #end
#end
}
// *** junto a la casa ***
union{
 object{grass_patch}
 texture{
  pigment{
   bozo turbulence 1
   color_map{
    [0.0 Gold*.2+Green*.2+Gray10+Yellow*.2]
    [1.0 Green*.3+Gold*.1+Gray10+Yellow*.1]
   }
   frequency 2
  }
  scale 100
  translate 1000*rand(r_plant)
 }
 rotate (360*rand(r_plant))*y
 scale <1.5,90,1.5>
 scale .0005+0.001*rand(r_plant)
 scale 4
 translate <-650,30,850>
}

#end
#if (use_stones)
#include "i_stnmcr.inc"
// *** box shape points ***
#declare a_points=array[8]
#declare a_points[0]=<-1,-1,-1>;
#declare a_points[1]=< 1,-1,-1>;
#declare a_points[2]=< 1, 1,-1>;
#declare a_points[3]=<-1, 1,-1>;
#declare a_points[4]=<-1,-1, 1>;
#declare a_points[5]=< 1,-1, 1>;
#declare a_points[6]=< 1, 1, 1>;
#declare a_points[7]=<-1, 1, 1>;
// *** box shape triangles (vector elem. refers to point in a_points[]) ***
#declare a_triang=array[12]
#declare a_triang[0]=<1,3,0>;
#declare a_triang[1]=<1,3,2>;
#declare a_triang[2]=<1,6,5>;
#declare a_triang[3]=<1,6,2>;
#declare a_triang[4]=<5,7,6>;
#declare a_triang[5]=<5,7,4>;
#declare a_triang[6]=<0,7,3>;
#declare a_triang[7]=<0,7,4>;
#declare a_triang[8]=<3,6,7>;
#declare a_triang[9]=<3,6,2>;
#declare a_triang[10]=<0,5,4>;
#declare a_triang[11]=<0,5,1>;
// *** randomize and subdivide the "seed" shape ***
Subdivide_Array(a_points,a_triang,r_stone)
Randomize_Array(a_points,.6,r_stone)
Subdivide_Array(a_points,a_triang,r_stone)
Randomize_Array(a_points,.4,r_stone)
Subdivide_Array(a_points,a_triang,r_stone)
Randomize_Array(a_points,.3,r_stone)
#declare stone=
object{
 Build_Stone(a_points,r_stone)
}
#declare stones=
union{
#declare cnt_stones=0;
#while (cnt_stones<num_stones*.5)
 #declare Norm = <0, 0, 0>;
 #declare Start = <-.2+.7*rand(r_stone),.6,-.5+rand(r_stone)>;
 #declare Direc = <0,-1,0>;
 #declare Inter=trace ( land, Start, Direc, Norm );
 #if (Inter.y>.05 & Inter.y<.26)
  object{stone
   texture{
    T_Grnt3
    normal{granite scale .1}
    scale 100
    translate 1000*rand(r_stone)
   }
   rotate (360*rand(r_stone))
   scale <1.5,90,1.5>
   scale 0.001
   scale .2+.8*rand(r_stone)
   translate <Start.x,Inter.y,Start.z>
  }
  #declare cnt_stones=cnt_stones+1;
 #end
#end
#declare cnt_stones=0;
#while (cnt_stones<num_stones*2)
 #declare Norm = <0, 0, 0>;
 #declare Start = <-.2+.7*rand(r_stone),.6,-.5+rand(r_stone)>;
 #declare Direc = <0,-1,0>;
 #declare Inter=trace ( land, Start, Direc, Norm );
 #if (Inter.y>.1 & Inter.y<.26)
  object{stone
   texture{
    T_Grnt3
    normal{granite scale .1}
    scale 100
    translate 1000*rand(r_stone)
   }
   rotate (360*rand(r_stone))
   scale <1.5,90,1.5>
   scale 0.001
   scale .2+.2*rand(r_stone)
   translate <Start.x,Inter.y,Start.z>
  }
  #declare cnt_stones=cnt_stones+1;
 #end
#end
}
#end
#declare puente_base=
height_field{
 png "hf_puente"
 water_level 0.01
 translate -.5
 rotate -90*x
}
#declare puente=
union{
 object{puente_base}
 object{puente_base scale <1,1,.1> translate <0,.1,.45>}
 object{puente_base scale <1,1,.1> translate <0,.1,-.45>}
 scale <1200,200,160>
 texture{
  pigment{Flesh}
  normal{granite scale 2}
 }
}
object{puente
 rotate 90*y
 translate <-2,-40,5700>
}
object{puente
 rotate 90*y        	
 translate <2700,-40,5700>
}