/*

  MARJAL.POV

  Marjal ("Marsh"), Jaime Vives Piqueres, (?)2001.

*/

// *** THAT'S MEGAPOV CODE ***
#version 3.5;


// *** STANDARD INCLUDES ***
#include "colors.inc"
#include "textures.inc"
#include "stones.inc"
#include "metals.inc"
#include "woods.inc"
#include "skies.inc"


// *** CONTROL ***
#declare use_water     =1;
#declare use_house     =1;
#declare use_boats     =1;
#declare use_plants    =1;
#declare use_grass     =1;
#declare use_reeds     =1;
#declare use_stones    =1;
#declare use_trees     =1;
#declare use_ambient   =1;
#declare use_radiosity =0;
#declare use_blur      =0;
#declare num_plants    =10000;
#declare num_grass     =14000;
#declare num_stones    =100;
#declare r_plant       =seed(44);
#declare r_stone       =seed(59);
#declare hf_hres       =50*3;
#declare hf_vres       =25*3;
#declare terrhf_k      =4;
#declare r_sun         =seed(22); //10,
#declare c_from        =<-1400,1196,-5500>;
#declare c_to          =<-230,0,-220>;


// *** GLOBBAL SETTINGS ***
global_settings{
 max_trace_level 32
 #if (use_radiosity)
  ambient_light 0.0
  #include "i_radiosity.inc"
 #end
}

// *** TEXTURES ***
#include "i_textures.inc"


// *** LAND AND PLANTS ***
#include "i_land.inc"
object{land
 hollow
 scale <9000,150,9000>
 texture{t_terr2}
 translate <100,-10,250>
}
object{land
 hollow
 scale <9000,150,9000>
 texture{t_terr2}
 translate <100,-10,250+9000>
}
object{land_fake
 hollow
 scale <9000,150,9000>
 texture{t_terr2}
 translate <100+9000,-10,250+9000>
}
#if (use_plants)
object{plants
 scale <9000,150,9000>
 translate <100,-10,250>
}
object{plants
 scale <9000,150,9000>
 translate <100,-10,250+9000>
}
#end
#if (use_grass)
object{grass
 scale <9000,150,9000>
 translate <100,-10,250>
}
object{grass
 scale <9000,150,9000>
 translate <100,-10,250+9000>
}
#end
#if (use_stones)
object{stones
 scale <9000,150,9000>
 translate <100,-10,250>
}
object{stones
 scale <9000,150,9000>
 translate <100,-10,250+9000>
}
#end
#if (use_reeds)
#include "i_reeds.inc"
object{reeds1
 scale 3.1
 translate <185,-12,555>
}
object{reeds2
 scale 3.4
 rotate 90*y
 translate <185,-12,405>
}
object{reeds2
 scale 3.1
 translate <125,-12,755>
}
object{reeds1
 scale 3.2
 rotate 18*y
 translate <105,-12,5205>
}
object{reeds2
 scale 3.4
 rotate 180*y
 translate <-1175,-12,4275>
}
object{reeds1
 scale 3
 rotate 118*y
 translate <-1150,-12,4405>
}
object{reeds2
 scale 3.3
 rotate 80*y
 translate <-135,-12,6475>
}
object{reeds1
 scale 3.2
 rotate 18*y
 translate <-135,-12,6205>
}
object{reeds2
 scale 3.3
 rotate 180*y
 translate <135,-12,3075>
}
object{reeds1
 scale 3.2
 rotate 180*y
 translate <135,-12,2805>
}
object{reeds2
 scale 3.4
 rotate 80*y
 translate <-170,-12,2900>
}
object{reeds1
 scale 3.1
 rotate 110*y
 translate <-125,-12,2805>
}
object{reeds1
 scale 3.1
 rotate 90*y
 translate <-135,-12,-1205>
}
object{reeds1
 scale 3.1
 rotate 180*y
 translate <-135,-12,-1805>
}
object{reeds2
 scale 3.1
 translate <-130,-12,-1675>
}
object{reeds2
 scale 3.3
 rotate 90*y
 translate <2155,-12,2675>
}
object{reeds1
 scale 3.2
 rotate -90*y
 translate <2135,-12,3805>
}
object{reeds1
 scale 3.2
 rotate 180*y
 translate <1835,-12,3805>
}
object{reeds1
 scale 3.3
 rotate 80*y
 translate <2035,-12,3825>
}
object{reeds2
 scale 3.3
 rotate 18*y
 translate <1945,-12,3805>
}
object{reeds2
 scale 3.4
 rotate 10*y
 translate <2455,-12,6075>
}
object{reeds1
 scale 3.1
 rotate 0*y
 translate <2435,-12,6205>
}
#end


// *** HOUSE ***
#if (use_house)
#include "i_house.inc"
object{house rotate 0*y translate <-350,-2,750>}
object{house rotate 180*y translate <2100,-2,6300>}
#end


// *** TYPICAL VALENCIAN BOAT (called "Albuferenc") ***
#if (use_boats)
#include "i_boats.inc"
#declare barcas=
union{
object{albuferenc
 rotate 95*y
 translate <150,25,-700>
}
object{albuferenc
 rotate 75*y
 translate <250,25,-600>
}
object{albuferenc
 rotate 15*y
 translate <450,25,-450>
}
}
#declare barcas_falsas=
union{
object{albuferenc0
 rotate 95*y
 translate <150,25,-700>
}
object{albuferenc0
 rotate 75*y
 translate <250,25,-600>
}
object{albuferenc0
 rotate 15*y
 translate <450,25,-450>
}
}
object{barcas translate <400,1,6800>}
#end

// *** WATER AND FLOOR FILLING ***
#if (use_water>0)
#if (use_boats)
difference{
 box{-.5,.5 scale <12000,100,30000>}
 object{barcas_falsas
  translate <400,1,6800>
 }
 hollow
 #if (use_water=2)
 texture{t_water}
 #else
 material{m_water}
 #end
 translate -49*y
}
#else
box{-.5,.5 scale <12000,100,30000>
 hollow
 #if (use_water=2)
 texture{t_water}
 #else
 material{m_water}
 #end
 translate -49*y
}
#end
#end


// *** SUNLIGHT & ATMOSPHERE ***
#debug "\nAdd random Sunlight\n"
#declare lrx=(-90+180*rand(r_sun));
#declare lry=(360*rand(r_sun));
light_source{
 <0,1000000,0>
 (White+Gold*.75+SkyBlue*.25)*.5
 fade_distance 5000000
 fade_power 2
 rotate lrx*x
 rotate lry*y
}
// simulation of ambient
#if (use_ambient)
#declare nl=16;
#declare il=0;
#while (il<nl)
light_source{
 <0,1000000,0>
 (White+Gold*.75+SkyBlue*.25)*.04
 fade_distance 5000000
 fade_power 2
 shadowless
 rotate 65*x
 rotate (360*il/nl)*y
}
#declare il=il+1;
#end
#end
sky_sphere{
 pigment{
  bozo turbulence 1 lambda 3
  color_map{
   [0.0 SummerSky]
   [0.4 SummerSky]
   [0.7 White]
   [1.0 White*.8]
  }
 }
 scale <1,1/3,1>
 scale .2
}
fog{fog_type 2 SummerSky*.3+White*.7 filter .2 distance 50000 fog_alt 2000}
plane{ y,-40 hollow
 texture{t_terr2}
}


// *** CAMERA ***
// settings are in the same scale as the whole scene
camera{
 location c_from
 right <4,0,0>
 up <0,3,0>
 direction 10*z
 look_at c_to
 #if (use_blur)
  aperture 120
  blur_samples 8
  focal_point c_to
 #end
}


#declare t_madera_carro=texture{T_Wood10}
#declare plataforma_carro=
union{
 box{-.5,.5 scale <160,5,200>}
 box{-.5,.5 scale <160,40,40> translate <0,25,-60>}
 box{-.5,.5 scale <160,4,8> translate <0,0,-130>}
 box{-.5,.5 scale <160,20,2> translate <0,35,98>}
 cylinder{<-87,0,0>,< 87,0,0>,4}
 cylinder{< 78,0,-250>,< 78,0,100>,4}
 cylinder{<-78,0,-250>,<-78,0,100>,4}
 cylinder{<78,35,-100>,<78,35,100>,4}
 cylinder{<78,70,-100>,<78,70,100>,3}
 cylinder{<-78,35,-100>,<-78,35,100>,4}
 cylinder{<-78,70,-100>,<-78,70,100>,3}
 #declare num_rej=10;
 #declare cnt_rej=0;
 #while (cnt_rej<num_rej)
  cylinder{<0,0,0>,<0,70,0>,2 translate <-78,0,(-100+200*cnt_rej/num_rej)>}
  cylinder{<0,0,0>,<0,70,0>,2 translate < 78,0,(-100+200*cnt_rej/num_rej)>}
  #declare cnt_rej=cnt_rej+1;
 #end
 texture{t_madera_carro}
}
#declare rueda_carro=
union{
 difference{
  cylinder{<-3,0,0>,<3,0,0>,80}
  cylinder{<-3.1,0,0>,<3.1,0,0>,77}
 }
 difference{
  cylinder{<-2,0,0>,<2,0,0>,77}
  cylinder{<-2.1,0,0>,<2.1,0,0>,74}
 }
 cylinder{<-6,0,0>,<6,0,0>,10}
 #declare num_radios_rc=16;
 #declare cnt_radios_rc=0;
 #while (cnt_radios_rc<num_radios_rc)
  cylinder{<0,0,0>,<0,80,0>,2.5 rotate (360*cnt_radios_rc/num_radios_rc)*x}
  #declare cnt_radios_rc=cnt_radios_rc+1;
 #end
 texture{t_madera_carro rotate 90*y}
}
#declare carro=
union{
 object{plataforma_carro rotate -18*x translate 5*y}
 object{rueda_carro translate  85*x}
 object{rueda_carro translate -85*x}
 translate 80*y
}
object{carro
 scale .6
 rotate 50*y
 translate <-650,30,850>
}


// *** trees ***
#if (use_trees)
#include "treemacr.inc"
// *** this tree parameters ***
#declare base_radius           =10; // trunk base radius
#declare top_radius            =1;  // trunk top radius (keep it low)
#declare sections              =30; // total trunk sections
#declare start_section_lenght  =15; // first section lenght
#declare end_section_lenght    =5;  // last section lenght
#declare branch_start_section  =10; // trunk section for first branch
#declare branch_end_section    =20; // trunk section for last, vertical branch
#declare startbranch_sections  =20; // number of sections for 1st branch
#declare startsbranch_sections =15; //        "            "   " sub-branch
#declare startlbranch_sections =10; //        "            "   " last-branch
#declare branch_v_min_angle    =20; // minimum vertical angle for branches
#declare branch_v_max_angle    =80; //    "       "       "    "  branches
#declare branch_h_rotation     =60; // succesive rotation angle for branches (horizontal)
#declare sbranch_v_min_angle   =20; // idem for sub-branches
#declare sbranch_v_max_angle   =80;
#declare sbranch_h_rotation    =60;
#declare fbranch_v_min_angle   =20; // idem for last-branches
#declare fbranch_v_max_angle   =80;
#declare fbranch_h_rotation    =60;
#declare leaves_rotation       =60; // succ. horizontal rotation for leaves
#declare branchs_per_section   =1;  // number of branches per section
#declare branch_percentage     =.3; // percentage of branches (1 means all sections have branches)
#declare sbranch_percentage    =.4; // idem for sub-branches
#declare lbranch_percentage    =.6; // idem for last-branches
#declare leaves_percentage     =.9; // idem for leaves
#declare verticality           =.5; // trunk/branch verticallity percentage
#declare pcurves                =.5; //      "       curves percentage
#declare number_of_roots       =3;
#declare bark_texture          =texture{t_bark}
#declare i_leaf                ="i_leaves.inc"
#declare l_switch              =on; // leaves on/off
// and finally the mos important! Change it and trace again: many times
// results are wierd, but in some ocasions it makes very nice trees.
#declare random_seed           =127;
// *** create the tree calling the include ***
#declare arbol01=
#include "tree.inc"

// *** place the tree ***
object{arbol01
 scale 2
 rotate 40*y
 translate <1775,1,6000>
}
object{arbol01
 scale 2.1
 rotate 120*y
 translate <-800,1,1500>
}
#end